/*
.Howto get port type (RS-232 or RS-422/485) from advantech adv950 driver.
	
    .using devce ioctl code DCMD_CHR_LINESTATUS, it return a int data;
    #define PORTTYPE	0x10
    (data & PORTTYPE) = 0;  <-- RS-232
    (data & PORTTYPE) = 1;  <-- RS-422/485
    data bit[0] 	= RTS
    data bit[1] 	= DTR
    data bit[12]	= CTS
    data bit[13]	= DSR
    data bit[14]	= RI
    data bit[15]	= CD
    
    
example:
*/
#include <stdio.h>
#include <devctl.h>
#include <sys/dcmd_chr.h>
#include <fcntl.h>
#define PORTTYPE 0x10
int 
main(void)
{
	int fd, data,i;
	char ttyname[10];
	for ( i =1; i<=32; i++ ) 
	{
		sprintf(ttyname,"/dev/ttyAP%d",i);
		 fd = open(ttyname, O_RDWR);
		if(fd == -1)
		{
			return -1;
		}
		if (devctl (fd, DCMD_CHR_LINESTATUS, &data, sizeof(data), NULL)){
	   		printf("error\n");
		}
		if(data & PORTTYPE)
			printf("%s was set as RS-422/485\n",ttyname);
		else
			printf("%s was set as RS-232\n",ttyname);
		
		close(fd);
	}
	return;
}
	
//. read /etc/system/config/serial-traplist  to get what card's port number is.



